Subject: Re: [bug] stuck localhost TCP connections, v2.6.26-rc3+

From: Ingo Molnar <[email-masked]>
Date: Fri, 30 May 2008 13:09:04 +0200

* Ingo Molnar <[email-masked]> wrote:

> btw., i now also have a hung socket over real network:

last night i turned off distcc support, and got about 200 successful 
bootups and zero TCP hangs (as expected - there's not much TCP traffic 
if the distcc cluster is not utilized).

but that's 200 overnight tests instead of the expected 600, so this is a 
major and rather crippling bug to me.

There's no good way to detect these hung sockets by me from userspace 
and get rid of them. Has anyone before thought of the obvious: to write 
a kernel-space "TCP socket watchdog" kernel feature that detects them 
and tries to free them so that people can become aware of it?

Hung sockets is a re-occuring bug in the TCP stack after all. (and it's 
a natural property of it: state machine designs are always vulnerable to 
lost event problems.)

	Ingo